﻿using EJGrid.Models;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace EJGrid.Controllers
{
    public class HomeController : Controller
    {
        private NORTHWNDEntities db = new NORTHWNDEntities();
        public ActionResult Index()
        {
            //ViewBag.datasource = OrderRepository.GetAllRecords2().ToList();
            Session["SqlDataSource"] = db.Orders.ToList();
            return View();
        }
     
        public class DataResult
        {
            public IEnumerable<Order> result { get; set; }
            public int count { get; set; }
        }
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Update(Order value)
        {
            if (ModelState.IsValid)
            {
                db.Entry(value).State = EntityState.Modified;
                db.SaveChangesAsync();
                return RedirectToAction("Index");
                //return Json(value, JsonRequestBehavior.AllowGet);
            }
            return View(value);
        }
        [ValidateAntiForgeryToken]
        public ActionResult Insert(Order value)
        {
           db.Orders.Add(value);
            db.SaveChanges();
            var data = db.Orders.ToList();
           var val = data.Last();
            return Json(val, JsonRequestBehavior.AllowGet); 
        }
        public ActionResult Remove(int key)
        {
            Order order = db.Orders.Find(key);
            db.Orders.Remove(order);
            db.SaveChanges();
            return Json(order, JsonRequestBehavior.AllowGet); 
        }

        public ActionResult UrlDataSource(DataManager dm)
        {
            IEnumerable DataSource = db.Orders.ToList();
            DataOperations ds = new DataOperations();
            List<string> str = new List<string>();
            if (dm.Search != null && dm.Search.Count > 0)
            {
                DataSource = ds.PerformSearching(DataSource, dm.Search);
            }
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                DataSource = ds.PerformSorting(DataSource, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                DataSource = ds.PerformWhereFilter(DataSource, dm.Where, dm.Where[0].Operator);
            }
            var count = DataSource.Cast<Order>().Count();
            DataSource = ds.PerformSkip(DataSource, dm.Skip);
            DataSource = ds.PerformTake(DataSource, dm.Take);
                return Json(new { result = DataSource, count = count });
        }
        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}